package Figure2D;

public class Poligono extends Figura2D {
	
	private Punto[] vertici;
	
	public Poligono(int n) {
		vertici = new Punto[n];
		for (int i=0; i<vertici.length; i++) {
			vertici[i] = null;
		}
	}

	public void addVertice(Punto v) {
		int i = 0;
		while( i < vertici.length  && vertici[i] != null) i++;
		
		// i ora punta "fuori" dall'array, oppure alla sua prima componente nulla.
		if ( i < vertici.length ) {
			// "i" e' la prima componente nulla dell'array
			vertici[i] = v;
		}		
	}



	public double perimetro() { 
		double result = 0;		
		if (vertici[0] == null) return 0;
		int i=0; 
		while( i < vertici.length-1  && vertici[i+1] != null) {
			result += Util.lunghezza(  vertici[i], vertici[i+1] );
			i++;
		}
		
		result += Util.lunghezza(  vertici[i], vertici[0] );		
		return result;
	}



	public double area() { 
		// Da fare!
		
		/* Suggerimento: si puo' procedere per integrazione.
		   L'integrale lungo una curva chiusa  pari all'area della porzione di piano
		   racchiusa dalla curva.
		   
		   La curva in questo caso  una "spezzata", e calcolare "l'integrale" di un segmento
		   significa calcolare l'area di un trapezio. Attenzione al segno delle aree
		   calcolate e sommate tra di loro!
		*/
		return -1;
	}



	public String toString() {
		// [ <vertice0> .... verticeN ]		
		String result = "[";
		for(int i=0; i<vertici.length; i++) {
			result = result + vertici[i];
		}
		result = result + "]";
		return result;	
	}


	public boolean equals(Object o) {
		if (o == null) return false;
		if (! (o instanceof Poligono) ) return false;
		
		Poligono oo = (Poligono)o;		
		if (this.vertici.length != oo.vertici.length) return false;		
		if (this.vertici.length == 0) return true;
		
		// 1. Trova la componente dell'array oo.vertici che contiene un vertice `equal'
		//    a this.vertici[0].
		int inizioOO = 0;
		while ( inizioOO < vertici.length && 
				!oo.vertici[inizioOO].equals( this.vertici[0] ) ) {
			inizioOO++;
		}
		
		if (inizioOO == vertici.length) return false;		
		if (vertici.length == 1) return true;		
		// inizioOO  la componente di oo da cui partire!	
		
		// 2. Decidi il "verso" con cui percorrere (circolarmente) `oo' a partire 
		//    dalla posizione "inizioOO".
		boolean versoDestra;
		
		
		// 2.a: Provo a guardare a destra...
		// Nota: this.vertici[1] esiste, visto che vertici.length > 1 
		// (cf. verifiche precedenti)
		if (  oo.vertici[  avanza(inizioOO, true) ].equals( this.vertici[1] ) ) 
				versoDestra = true;
		else {
			// 2.b: Provo a guardare a sinistra...
			if (  oo.vertici[  avanza(inizioOO, false) ].equals( this.vertici[1] ) ) 
				versoDestra = false;			
			else return false; // Non sono equal!
		}
		// ora `versoDestra'  settato correttamente.
		
		
		// 3. Scandisci in parallelo this.vertici e oo.vertici, con l'accortezza che:
		//    -- oo.vertici va scandito a partire dall'indice inizioOO
		//    -- oo.vertici va scandito in modo circolare secondo il verso `versoDestra'
		//       (cf. metodo di supporto avanza()).
		int posCorrenteThis = 0;
		int posCorrenteOO = inizioOO;
		
		while (posCorrenteThis < this.vertici.length) {
			if (  !this.vertici[posCorrenteThis].equals(oo.vertici[posCorrenteOO]) ) {
				return false;
			}				
			posCorrenteThis ++;			
			posCorrenteOO = avanza( posCorrenteOO, versoDestra );	
		}
		return true; // Sono uguali!		
	}


	private int avanza(int indice, boolean versoDestra) {
		if (versoDestra) {
			if (indice >= vertici.length-1) return 0;
			else return indice+1;
		}
		else {
			if (indice <= 0) return vertici.length-1;
			else return indice-1;
		}
	}


} //:~
