package Figure2D;


public class Triangolo extends Figura2D {

	private Punto a, b, c;
	
	public Triangolo( Punto aa, Punto bb, Punto cc ) {
			a = aa;
			b = bb; 
			c = cc;
	}
	
	public Punto getVerticeA() { return a; }
	public Punto getVerticeB() { return b; }	
	public Punto getVerticeC() { return c; }	


	public String toString() {
		// [ <xa,ya>,  <xb,yb>,  <xc,yc> ]
		return "[" + a + ", " + b + ", " + c + "]";
	}


	public double perimetro() {
		return 	Util.lunghezza(this.a, this.b) + 
				Util.lunghezza(this.b, this.c) + 
				Util.lunghezza(this.a, this.c);
	}
	
	public double area() {
		/* Formula di Erone */
		double p = this.perimetro()/2;
		
		return Math.sqrt(   
					p * ( p - Util.lunghezza(a,b) ) *
						( p - Util.lunghezza(b,c) ) *
						( p - Util.lunghezza(c,a) )						
		);
	}
	
	public boolean equals(Object o) {
		if (o == null) return false;
		if (! (o instanceof Triangolo) ) return false;
				
		Triangolo oo = (Triangolo) o;
		return 	( this.a.equals(oo.a) && this.b.equals(oo.b) && this.c.equals(oo.c) )
				||
				( this.a.equals(oo.a) && this.b.equals(oo.c) && this.c.equals(oo.b) )
				||
				( this.a.equals(oo.b) && this.b.equals(oo.a) && this.c.equals(oo.c) )				
				||
				( this.a.equals(oo.b) && this.b.equals(oo.c) && this.c.equals(oo.b) )				
				||
				( this.a.equals(oo.c) && this.b.equals(oo.a) && this.c.equals(oo.b) )				
				||
				( this.a.equals(oo.c) && this.b.equals(oo.b) && this.c.equals(oo.a) );
	}


} //:~